/*---------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
'use strict';
var ContentLength = 'Content-Length: ';
var CRLF = '\r\n';
var MessageWriter = (function () {
    function MessageWriter(writable, encoding) {
        if (encoding === void 0) { encoding = 'utf8'; }
        this.writable = writable;
        this.encoding = encoding;
    }
    MessageWriter.prototype.write = function (msg) {
        var json = JSON.stringify(msg);
        var contentLength = Buffer.byteLength(json, this.encoding);
        var headers = [
            ContentLength, contentLength.toString(), CRLF,
            CRLF
        ];
        // Header must be written in ASCII encoding
        this.writable.write(headers.join(''), 'ascii');
        // Now write the content. This can be written in any encoding
        this.writable.write(json, this.encoding);
    };
    return MessageWriter;
})();
exports.MessageWriter = MessageWriter;
//# sourceMappingURL=messageWriter.js.map